"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouteResolver = void 0;
const route_1 = require("./route");
class RouteResolver {
    wh;
    routeConstructors;
    constructor(wh, routeConstructors) {
        this.wh = wh;
        this.routeConstructors = routeConstructors;
    }
    async findRoutes(request) {
        const matches = await Promise.all(this.routeConstructors
            .map((rc) => new rc(this.wh, request))
            .map(async (route) => {
            const match = (await route.isSupported()) && (!(0, route_1.isAutomatic)(route) || (await route.isAvailable()));
            return [match, match ? route : undefined];
        }));
        return matches.filter(([match]) => match).map(([, route]) => route);
    }
    async sortRoutes(routes, sortBy) {
        // TODO: actually sort
        return routes;
    }
}
exports.RouteResolver = RouteResolver;
//# sourceMappingURL=resolver.js.map