import { Network } from "@wormhole-foundation/sdk-base";
import { Signer } from "@wormhole-foundation/sdk-definitions";
import { AttestationReceipt, TransferQuote } from "../../types";
import { AutomaticRoute } from "../route";
import { Receipt, TransferParams, ValidatedTransferParams, ValidationResult } from "../types";
export declare namespace AutomaticTokenBridgeRoute {
    type Options = {
        nativeGas: number;
    };
    type NormalizedParams = {
        fee: bigint;
        amount: bigint;
        nativeGasAmount: bigint;
    };
    interface ValidatedParams extends ValidatedTransferParams<Options> {
        normalizedParams: NormalizedParams;
    }
}
type Op = AutomaticTokenBridgeRoute.Options;
type Vp = AutomaticTokenBridgeRoute.ValidatedParams;
type Tp = TransferParams<Op>;
type Vr = ValidationResult<Op>;
type Q = TransferQuote;
type R = Receipt<AttestationReceipt<"AutomaticTokenBridge">>;
export declare class AutomaticTokenBridgeRoute<N extends Network> extends AutomaticRoute<N, Op, R, Q> {
    NATIVE_GAS_DROPOFF_SUPPORTED: boolean;
    getDefaultOptions(): Op;
    isSupported(): Promise<boolean>;
    isAvailable(): Promise<boolean>;
    validate(params: Tp): Promise<Vr>;
    normalizeTransferParams(params: Tp): Promise<{
        fee: bigint;
        amount: bigint;
        nativeGasAmount: bigint;
    }>;
    quote(params: Vp): Promise<TransferQuote>;
    initiate(signer: Signer, params: Vp): Promise<R>;
    track(receipt: R, timeout?: number): AsyncGenerator<import("../../protocols/tokenTransfer").TokenTransferReceipt<"Solana" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Algorand" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Near" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Sui" | "Aptos" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Btc" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky", "Solana" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Algorand" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Near" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Sui" | "Aptos" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Btc" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky">, void, unknown>;
    private toTransferDetails;
}
export {};
//# sourceMappingURL=automatic.d.ts.map