import { Network } from "@wormhole-foundation/sdk-base";
import { Signer, TransactionId } from "@wormhole-foundation/sdk-definitions";
import { AttestationReceipt, TransferQuote, TransferReceipt } from "../../types";
import { ManualRoute } from "../route";
import { TransferParams, ValidatedTransferParams, ValidationResult } from "../types";
export declare namespace TokenBridgeRoute {
    type Options = {
        payload?: Uint8Array;
    };
    type NormalizedParams = {
        amount: bigint;
    };
    interface ValidatedParams extends ValidatedTransferParams<Options> {
        normalizedParams: NormalizedParams;
    }
}
type Op = TokenBridgeRoute.Options;
type Vp = TokenBridgeRoute.ValidatedParams;
type Tp = TransferParams<Op>;
type Vr = ValidationResult<Op>;
type Q = TransferQuote;
type R = TransferReceipt<AttestationReceipt<"TokenBridge">>;
export declare class TokenBridgeRoute<N extends Network> extends ManualRoute<N, Op, R, Q> {
    getDefaultOptions(): Op;
    isSupported(): Promise<boolean>;
    validate(params: Tp): Promise<Vr>;
    quote(params: Vp): Promise<TransferQuote>;
    initiate(signer: Signer, params: Vp): Promise<R>;
    complete(signer: Signer, receipt: R): Promise<TransactionId[]>;
    track(receipt: R, timeout?: number): AsyncGenerator<import("../../protocols/tokenTransfer").TokenTransferReceipt<"Solana" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Algorand" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Near" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Sui" | "Aptos" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Btc" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky", "Solana" | "Ethereum" | "Terra" | "Bsc" | "Polygon" | "Avalanche" | "Oasis" | "Algorand" | "Aurora" | "Fantom" | "Karura" | "Acala" | "Klaytn" | "Celo" | "Near" | "Moonbeam" | "Neon" | "Terra2" | "Injective" | "Osmosis" | "Sui" | "Aptos" | "Arbitrum" | "Optimism" | "Gnosis" | "Pythnet" | "Xpla" | "Btc" | "Base" | "Sei" | "Rootstock" | "Wormchain" | "Cosmoshub" | "Evmos" | "Kujira" | "Sepolia" | "ArbitrumSepolia" | "BaseSepolia" | "OptimismSepolia" | "Holesky">, void, unknown>;
    private toTransferDetails;
}
export {};
//# sourceMappingURL=manual.d.ts.map