import { Network } from "@wormhole-foundation/sdk-base";
import { Wormhole } from "../wormhole";
import { UnknownRoute, UnknownRouteConstructor } from "./route";
import { RouteTransferRequest } from "./request";
export type RouteSortOptions = "cost" | "speed";
export declare class RouteResolver<N extends Network> {
    wh: Wormhole<N>;
    routeConstructors: UnknownRouteConstructor<N>[];
    constructor(wh: Wormhole<N>, routeConstructors: UnknownRouteConstructor<N>[]);
    findRoutes(request: RouteTransferRequest<N>): Promise<UnknownRoute<N>[]>;
    sortRoutes(routes: UnknownRoute<N>[], sortBy: RouteSortOptions): Promise<UnknownRoute<N>[]>;
}
//# sourceMappingURL=resolver.d.ts.map