import { isAutomatic } from "./route";
export class RouteResolver {
    wh;
    routeConstructors;
    constructor(wh, routeConstructors) {
        this.wh = wh;
        this.routeConstructors = routeConstructors;
    }
    async findRoutes(request) {
        const matches = await Promise.all(this.routeConstructors
            .map((rc) => new rc(this.wh, request))
            .map(async (route) => {
            const match = (await route.isSupported()) && (!isAutomatic(route) || (await route.isAvailable()));
            return [match, match ? route : undefined];
        }));
        return matches.filter(([match]) => match).map(([, route]) => route);
    }
    async sortRoutes(routes, sortBy) {
        // TODO: actually sort
        return routes;
    }
}
//# sourceMappingURL=resolver.js.map